apiVersion: apps/v1
kind: Deployment
metadata:
  name: {{ include "octopoes.fullname" . }}-api
  labels:
    {{- include "octopoes.labels" . | nindent 4 }}
    app.kubernetes.io/component: api
spec:
  replicas: {{ .Values.api.replicaCount }}
  selector:
    matchLabels:
      {{- include "octopoes.selectorLabels" . | nindent 6 }}
  template:
    metadata:
      {{- with .Values.podAnnotations }}
      annotations:
        {{- toYaml . | nindent 8 }}
      {{- end }}
      labels:
        {{- include "octopoes.selectorLabels" . | nindent 8 }}
    spec:
      {{- with .Values.imagePullSecrets }}
      imagePullSecrets:
        {{- toYaml . | nindent 8 }}
      {{- end }}
      serviceAccountName: {{ include "octopoes.serviceAccountName" . }}
      securityContext:
        {{- toYaml .Values.podSecurityContext | nindent 8 }}
      containers:
        - name: {{ .Chart.Name }}
          securityContext:
            {{- toYaml .Values.securityContext | nindent 12 }}
          image: "{{ .Values.image.repository }}:{{ .Values.image.tag | default .Chart.AppVersion }}"
          imagePullPolicy: {{ .Values.image.pullPolicy }}
          ports:
            - name: http-octopoes
              containerPort: 8000
              protocol: TCP
          livenessProbe:
            httpGet:
              path: /openapi.json
              port: http
          readinessProbe:
            httpGet:
              path: /_dev/health
              port: http
          env:
            - name: XTDB_URI
              value: {{ required "xtdbURI is required" .Values.config.xtdbURI }}
            - name: QUEUE_URI
              value: {{ required "queueURI is required"  .Values.config.queueURI }}
            - name: LOG_CFG
              value: {{ .Values.config.logCfg }}
            - name: QUEUE_NAME_OCTOPOES
              value: {{ .Values.config.queueName }}
          resources:
            {{- toYaml .Values.resources | nindent 12 }}
      {{- with .Values.nodeSelector }}
      nodeSelector:
        {{- toYaml . | nindent 8 }}
      {{- end }}
      {{- with .Values.affinity }}
      affinity:
        {{- toYaml . | nindent 8 }}
      {{- end }}
      {{- with .Values.tolerations }}
      tolerations:
        {{- toYaml . | nindent 8 }}
      {{- end }}
